=== debian/changelog ===
rumur (2025.08.31-1) unstable; urgency=medium

  * New upstream release.
  * Update Standards-Version from 4.7.0 to 4.7.2.
  * Update CMake build requirement from 3.2 to 3.5. Closes: #1113481.

 -- Matthew Fernandez <matthew.fernandez@gmail.com>  Sun, 31 Aug 2025 20:59:02 -0700
