=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Enable all hardening compiler flags (-D_FORTIFY_SOURCE=2 -Wl,-z,now ...)
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# for DEB_VERSION
include /usr/share/dpkg/pkg-info.mk

# Override native version number with Debianized version number
export RUMUR_VERSION=v${DEB_VERSION}

%:
	dh $@
